package labss.lang.il.builders;

import org.whole.lang.builders.GenericIdentityBuilder;
import org.whole.lang.contexts.IEntityContext;
import org.whole.lang.reflect.EntityDescriptor;
import labss.lang.il.reflect.ILEntityDescriptorEnum;
import org.whole.lang.reflect.FeatureDescriptor;
import labss.lang.il.reflect.ILFeatureDescriptorEnum;

/** 
 * @generator Whole
 */
public class ILGenericBuilderAdapter extends GenericIdentityBuilder {
	private IILBuilder specificBuilder;

	public ILGenericBuilderAdapter(IILBuilder specificBuilder) {
		this.specificBuilder = specificBuilder;
	}

	public ILGenericBuilderAdapter(IILBuilder specificBuilder,
			IEntityContext entityContext) {
		this(specificBuilder);
		wSetEntityContext(entityContext);
	}

	public void visit() {
	}

	public void wEntity(EntityDescriptor<?> entityDesc) {
		switch (entityDesc.ordinal) {
		case ILEntityDescriptorEnum.BlockStatement_ord:
			specificBuilder.BlockStatement();
			break;
		case ILEntityDescriptorEnum.IfStatement_ord:
			specificBuilder.IfStatement();
			break;
		case ILEntityDescriptorEnum.IfElseStatement_ord:
			specificBuilder.IfElseStatement();
			break;
		case ILEntityDescriptorEnum.WhileStatement_ord:
			specificBuilder.WhileStatement();
			break;
		case ILEntityDescriptorEnum.AssignmentStatement_ord:
			specificBuilder.AssignmentStatement();
			break;
		case ILEntityDescriptorEnum.Addition_ord:
			specificBuilder.Addition();
			break;
		case ILEntityDescriptorEnum.Subtraction_ord:
			specificBuilder.Subtraction();
			break;
		case ILEntityDescriptorEnum.Multiplication_ord:
			specificBuilder.Multiplication();
			break;
		case ILEntityDescriptorEnum.Division_ord:
			specificBuilder.Division();
			break;
		case ILEntityDescriptorEnum.And_ord:
			specificBuilder.And();
			break;
		case ILEntityDescriptorEnum.Or_ord:
			specificBuilder.Or();
			break;
		case ILEntityDescriptorEnum.Not_ord:
			specificBuilder.Not();
			break;
		case ILEntityDescriptorEnum.Equals_ord:
			specificBuilder.Equals();
			break;
		case ILEntityDescriptorEnum.LessThan_ord:
			specificBuilder.LessThan();
			break;
		case ILEntityDescriptorEnum.GreaterThan_ord:
			specificBuilder.GreaterThan();
			break;
		}
	}

	public void wEntity_(EntityDescriptor<?> entityDesc) {
		switch (entityDesc.ordinal) {
		case ILEntityDescriptorEnum.BlockStatement_ord:
			specificBuilder.BlockStatement_();
			break;
		case ILEntityDescriptorEnum.IfStatement_ord:
			specificBuilder.IfStatement_();
			break;
		case ILEntityDescriptorEnum.IfElseStatement_ord:
			specificBuilder.IfElseStatement_();
			break;
		case ILEntityDescriptorEnum.WhileStatement_ord:
			specificBuilder.WhileStatement_();
			break;
		case ILEntityDescriptorEnum.AssignmentStatement_ord:
			specificBuilder.AssignmentStatement_();
			break;
		case ILEntityDescriptorEnum.Addition_ord:
			specificBuilder.Addition_();
			break;
		case ILEntityDescriptorEnum.Subtraction_ord:
			specificBuilder.Subtraction_();
			break;
		case ILEntityDescriptorEnum.Multiplication_ord:
			specificBuilder.Multiplication_();
			break;
		case ILEntityDescriptorEnum.Division_ord:
			specificBuilder.Division_();
			break;
		case ILEntityDescriptorEnum.And_ord:
			specificBuilder.And_();
			break;
		case ILEntityDescriptorEnum.Or_ord:
			specificBuilder.Or_();
			break;
		case ILEntityDescriptorEnum.Not_ord:
			specificBuilder.Not_();
			break;
		case ILEntityDescriptorEnum.Equals_ord:
			specificBuilder.Equals_();
			break;
		case ILEntityDescriptorEnum.LessThan_ord:
			specificBuilder.LessThan_();
			break;
		case ILEntityDescriptorEnum.GreaterThan_ord:
			specificBuilder.GreaterThan_();
			break;
		}
	}

	public void wEntity_(EntityDescriptor<?> entityDesc, int initialCapacity) {
		switch (entityDesc.ordinal) {
		case ILEntityDescriptorEnum.BlockStatement_ord:
			specificBuilder.BlockStatement_(initialCapacity);
			break;
		}
	}

	public void _wEntity(EntityDescriptor<?> entityDesc) {
		switch (entityDesc.ordinal) {
		case ILEntityDescriptorEnum.BlockStatement_ord:
			specificBuilder._BlockStatement();
			break;
		case ILEntityDescriptorEnum.IfStatement_ord:
			specificBuilder._IfStatement();
			break;
		case ILEntityDescriptorEnum.IfElseStatement_ord:
			specificBuilder._IfElseStatement();
			break;
		case ILEntityDescriptorEnum.WhileStatement_ord:
			specificBuilder._WhileStatement();
			break;
		case ILEntityDescriptorEnum.AssignmentStatement_ord:
			specificBuilder._AssignmentStatement();
			break;
		case ILEntityDescriptorEnum.Addition_ord:
			specificBuilder._Addition();
			break;
		case ILEntityDescriptorEnum.Subtraction_ord:
			specificBuilder._Subtraction();
			break;
		case ILEntityDescriptorEnum.Multiplication_ord:
			specificBuilder._Multiplication();
			break;
		case ILEntityDescriptorEnum.Division_ord:
			specificBuilder._Division();
			break;
		case ILEntityDescriptorEnum.And_ord:
			specificBuilder._And();
			break;
		case ILEntityDescriptorEnum.Or_ord:
			specificBuilder._Or();
			break;
		case ILEntityDescriptorEnum.Not_ord:
			specificBuilder._Not();
			break;
		case ILEntityDescriptorEnum.Equals_ord:
			specificBuilder._Equals();
			break;
		case ILEntityDescriptorEnum.LessThan_ord:
			specificBuilder._LessThan();
			break;
		case ILEntityDescriptorEnum.GreaterThan_ord:
			specificBuilder._GreaterThan();
			break;
		}
	}

	public void wFeature(FeatureDescriptor featureDesc) {
		switch (featureDesc.ordinal) {
		case ILFeatureDescriptorEnum.condition_ord:
			specificBuilder.condition();
			break;
		case ILFeatureDescriptorEnum.trueBody_ord:
			specificBuilder.trueBody();
			break;
		case ILFeatureDescriptorEnum.falseBody_ord:
			specificBuilder.falseBody();
			break;
		case ILFeatureDescriptorEnum.variable_ord:
			specificBuilder.variable();
			break;
		case ILFeatureDescriptorEnum.expression_ord:
			specificBuilder.expression();
			break;
		case ILFeatureDescriptorEnum.exp1_ord:
			specificBuilder.exp1();
			break;
		case ILFeatureDescriptorEnum.exp2_ord:
			specificBuilder.exp2();
			break;
		case ILFeatureDescriptorEnum.exp_ord:
			specificBuilder.exp();
			break;
		}
	}

	public void wEntity(EntityDescriptor<?> entityDesc, boolean value) {
		switch (entityDesc.ordinal) {
		case ILEntityDescriptorEnum.BooleanLiteral_ord:
			specificBuilder.BooleanLiteral(value);
			break;
		}
	}

	public void wEntity(EntityDescriptor<?> entityDesc, int value) {
		switch (entityDesc.ordinal) {
		case ILEntityDescriptorEnum.IntLiteral_ord:
			specificBuilder.IntLiteral(value);
			break;
		}
	}

	public void wEntity(EntityDescriptor<?> entityDesc, String value) {
		switch (entityDesc.ordinal) {
		case ILEntityDescriptorEnum.Variable_ord:
			specificBuilder.Variable(value);
			break;
		}
	}
}
