package labss.lang.motomondiale.visitors;

import org.whole.lang.visitors.GenericTraversalFactory;
import org.whole.lang.visitors.IVisitor;
import org.whole.lang.visitors.IBinaryVisitor;
import org.whole.lang.visitors.IUnaryVisitor;

/** 
 * @generator Whole
 */
public class MotoMondialeTraversalFactory extends GenericTraversalFactory {
	public static final MotoMondialeTraversalFactory instance = new MotoMondialeTraversalFactory();

	private MotoMondialeTraversalFactory() {
	}

	protected IVisitor ensureSpecific(IVisitor visitor) {
		if (visitor instanceof IMotoMondialeVisitor)
			return visitor;
		else
			return new MotoMondialeForwardGenericVisitor(visitor);
	}

	public IVisitor failure() {
		return new MotoMondialeFailureVisitor();
	}

	public IVisitor identity() {
		return new MotoMondialeIdentityVisitor();
	}

	public IVisitor forwardStaged() {
		return new MotoMondialeForwardStagedVisitor();
	}

	public IBinaryVisitor sequence(IVisitor visitor1, IVisitor visitor2) {
		return new MotoMondialeSequenceVisitor(ensureSpecific(visitor1),
				ensureSpecific(visitor2));
	}

	public IUnaryVisitor traverseAll(IVisitor visitor1) {
		return new MotoMondialeTraverseAllVisitor(ensureSpecific(visitor1));
	}
}
