package labss.lang.regexp.builders;

import org.whole.lang.builders.GenericIdentityBuilder;
import org.whole.lang.contexts.IEntityContext;
import org.whole.lang.reflect.EntityDescriptor;
import labss.lang.regexp.reflect.RegExpEntityDescriptorEnum;
import org.whole.lang.reflect.FeatureDescriptor;
import labss.lang.regexp.reflect.RegExpFeatureDescriptorEnum;

/** 
 * @generator Whole
 */
public class RegExpGenericBuilderAdapter extends GenericIdentityBuilder {
	private IRegExpBuilder specificBuilder;

	public RegExpGenericBuilderAdapter(IRegExpBuilder specificBuilder) {
		this.specificBuilder = specificBuilder;
	}

	public RegExpGenericBuilderAdapter(IRegExpBuilder specificBuilder,
			IEntityContext entityContext) {
		this(specificBuilder);
		wSetEntityContext(entityContext);
	}

	public void visit() {
	}

	public void wEntity(EntityDescriptor<?> entityDesc, String value) {
		switch (entityDesc.ordinal) {
		case RegExpEntityDescriptorEnum.LiteralExp_ord:
			specificBuilder.LiteralExp(value);
			break;
		}
	}

	public void wFeature(FeatureDescriptor featureDesc) {
		switch (featureDesc.ordinal) {
		case RegExpFeatureDescriptorEnum.exp1_ord:
			specificBuilder.exp1();
			break;
		case RegExpFeatureDescriptorEnum.exp2_ord:
			specificBuilder.exp2();
			break;
		case RegExpFeatureDescriptorEnum.alt1_ord:
			specificBuilder.alt1();
			break;
		case RegExpFeatureDescriptorEnum.alt2_ord:
			specificBuilder.alt2();
			break;
		case RegExpFeatureDescriptorEnum.repetition_ord:
			specificBuilder.repetition();
			break;
		}
	}

	public void wEntity(EntityDescriptor<?> entityDesc) {
		switch (entityDesc.ordinal) {
		case RegExpEntityDescriptorEnum.SequenceExp_ord:
			specificBuilder.SequenceExp();
			break;
		case RegExpEntityDescriptorEnum.AlternationExp_ord:
			specificBuilder.AlternationExp();
			break;
		case RegExpEntityDescriptorEnum.RepetitionExp_ord:
			specificBuilder.RepetitionExp();
			break;
		}
	}

	public void wEntity_(EntityDescriptor<?> entityDesc) {
		switch (entityDesc.ordinal) {
		case RegExpEntityDescriptorEnum.SequenceExp_ord:
			specificBuilder.SequenceExp_();
			break;
		case RegExpEntityDescriptorEnum.AlternationExp_ord:
			specificBuilder.AlternationExp_();
			break;
		case RegExpEntityDescriptorEnum.RepetitionExp_ord:
			specificBuilder.RepetitionExp_();
			break;
		}
	}

	public void _wEntity(EntityDescriptor<?> entityDesc) {
		switch (entityDesc.ordinal) {
		case RegExpEntityDescriptorEnum.SequenceExp_ord:
			specificBuilder._SequenceExp();
			break;
		case RegExpEntityDescriptorEnum.AlternationExp_ord:
			specificBuilder._AlternationExp();
			break;
		case RegExpEntityDescriptorEnum.RepetitionExp_ord:
			specificBuilder._RepetitionExp();
			break;
		}
	}
}
